diff -ruN vdr-1.7.25/PLUGINS/src/epgtableid0/epgtableid0.c vdr-1.7.26/PLUGINS/src/epgtableid0/epgtableid0.c
--- vdr-1.7.25/PLUGINS/src/epgtableid0/epgtableid0.c	1970-01-01 01:00:00.000000000 +0100
+++ vdr-1.7.26/PLUGINS/src/epgtableid0/epgtableid0.c	2012-03-10 16:10:43.000000000 +0100
@@ -0,0 +1,98 @@
+/*
+ * epgtableid0.c: A plugin for the Video Disk Recorder
+ *
+ * See the README file for copyright information and how to reach the author.
+ *
+ * $Id: epgtableid0.c 1.1 2012/03/10 15:10:43 kls Exp $
+ */
+
+#include <vdr/epg.h>
+#include <vdr/plugin.h>
+
+static const char *VERSION        = "0.0.1";
+static const char *DESCRIPTION    = "EPG handler for events with table id 0x00";
+
+// --- cTable0Handler --------------------------------------------------------
+
+class cTable0Handler : public cEpgHandler {
+private:
+  bool Ignore(cEvent *Event) { return Event->TableID() == 0x00; }
+public:
+  virtual bool SetEventID(cEvent *Event, tEventID EventID);
+  virtual bool SetStartTime(cEvent *Event, time_t StartTime);
+  virtual bool SetDuration(cEvent *Event, int Duration);
+  virtual bool SetTitle(cEvent *Event, const char *Title);
+  virtual bool SetShortText(cEvent *Event, const char *ShortText);
+  virtual bool SetDescription(cEvent *Event, const char *Description);
+  virtual bool SetContents(cEvent *Event, uchar *Contents);
+  virtual bool SetParentalRating(cEvent *Event, int ParentalRating);
+  virtual bool SetVps(cEvent *Event, time_t Vps);
+  virtual bool FixEpgBugs(cEvent *Event);
+  };
+
+bool cTable0Handler::SetEventID(cEvent *Event, tEventID EventID)
+{
+  return Ignore(Event);
+}
+
+bool cTable0Handler::SetStartTime(cEvent *Event, time_t StartTime)
+{
+  return Ignore(Event);
+}
+
+bool cTable0Handler::SetDuration(cEvent *Event, int Duration)
+{
+  return Ignore(Event);
+}
+
+bool cTable0Handler::SetTitle(cEvent *Event, const char *Title)
+{
+  return Ignore(Event);
+}
+
+bool cTable0Handler::SetShortText(cEvent *Event, const char *ShortText)
+{
+  return Ignore(Event);
+}
+
+bool cTable0Handler::SetDescription(cEvent *Event, const char *Description)
+{
+  return Ignore(Event);
+}
+
+bool cTable0Handler::SetContents(cEvent *Event, uchar *Contents)
+{
+  return Ignore(Event);
+}
+
+bool cTable0Handler::SetParentalRating(cEvent *Event, int ParentalRating)
+{
+  return Ignore(Event);
+}
+
+bool cTable0Handler::SetVps(cEvent *Event, time_t Vps)
+{
+  return Ignore(Event);
+}
+
+bool cTable0Handler::FixEpgBugs(cEvent *Event)
+{
+  return Ignore(Event);
+}
+
+// --- cPluginEpgtableid0 ----------------------------------------------------
+
+class cPluginEpgtableid0 : public cPlugin {
+public:
+  virtual const char *Version(void) { return VERSION; }
+  virtual const char *Description(void) { return DESCRIPTION; }
+  virtual bool Initialize(void);
+  };
+
+bool cPluginEpgtableid0::Initialize(void)
+{
+  new cTable0Handler;
+  return true;
+}
+
+VDRPLUGINCREATOR(cPluginEpgtableid0); // Don't touch this!
diff -ruN vdr-1.7.25/PLUGINS/src/rcu/HISTORY vdr-1.7.26/PLUGINS/src/rcu/HISTORY
--- vdr-1.7.25/PLUGINS/src/rcu/HISTORY	2012-02-27 11:46:08.000000000 +0100
+++ vdr-1.7.26/PLUGINS/src/rcu/HISTORY	2012-03-07 15:23:27.000000000 +0100
@@ -4,3 +4,7 @@
 2012-02-27: Version 0.0.1
 
 - Initial revision.
+
+2012-03-07: Version 0.0.2
+
+- Added new parameter LiveView to ChannelSwitch().
diff -ruN vdr-1.7.25/PLUGINS/src/rcu/rcu.c vdr-1.7.26/PLUGINS/src/rcu/rcu.c
--- vdr-1.7.25/PLUGINS/src/rcu/rcu.c	2012-02-27 12:49:51.000000000 +0100
+++ vdr-1.7.26/PLUGINS/src/rcu/rcu.c	2012-03-07 15:22:44.000000000 +0100
@@ -3,7 +3,7 @@
  *
  * See the README file for copyright information and how to reach the author.
  *
- * $Id: rcu.c 1.1 2012/02/27 11:49:51 kls Exp $
+ * $Id: rcu.c 1.2 2012/03/07 14:22:44 kls Exp $
  */
 
 #include <getopt.h>
@@ -16,7 +16,7 @@
 #include <vdr/thread.h>
 #include <vdr/tools.h>
 
-static const char *VERSION        = "0.0.1";
+static const char *VERSION        = "0.0.2";
 static const char *DESCRIPTION    = "Remote Control Unit";
 
 #define REPEATLIMIT      150 // ms
@@ -44,7 +44,7 @@
   void SetString(const char *s);
   bool DetectCode(unsigned char *Code);
   virtual void Action(void);
-  virtual void ChannelSwitch(const cDevice *Device, int ChannelNumber);
+  virtual void ChannelSwitch(const cDevice *Device, int ChannelNumber, bool LiveView);
   virtual void Recording(const cDevice *Device, const char *Name, const char *FileName, bool On);
 public:
   cRcuRemote(const char *DeviceName);
@@ -353,9 +353,9 @@
   return false;
 }
 
-void cRcuRemote::ChannelSwitch(const cDevice *Device, int ChannelNumber)
+void cRcuRemote::ChannelSwitch(const cDevice *Device, int ChannelNumber, bool LiveView)
 {
-  if (ChannelNumber && Device->IsPrimaryDevice())
+  if (ChannelNumber && LiveView)
      SetNumber(cDevice::CurrentChannel());
 }
 
diff -ruN vdr-1.7.25/channels.c vdr-1.7.26/channels.c
--- vdr-1.7.25/channels.c	2011-08-26 14:44:21.000000000 +0200
+++ vdr-1.7.26/channels.c	2012-03-07 17:50:15.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: channels.c 2.19 2011/08/26 12:44:21 kls Exp $
+ * $Id: channels.c 2.20 2012/03/07 16:50:15 kls Exp $
  */
 
 #include "channels.h"
@@ -619,7 +619,8 @@
                        }
                     else
                        *alangs[NumApids] = 0;
-                    apids[NumApids++] = strtol(q, NULL, 10);
+                    if ((apids[NumApids] = strtol(q, NULL, 10)) != 0)
+                       NumApids++;
                     }
                  else
                     esyslog("ERROR: too many APIDs!"); // no need to set ok to 'false'
@@ -647,7 +648,8 @@
                           }
                        else
                           *dlangs[NumDpids] = 0;
-                       dpids[NumDpids++] = strtol(q, NULL, 10);
+                       if ((dpids[NumDpids] = strtol(q, NULL, 10)) != 0)
+                          NumDpids++;
                        }
                     else
                        esyslog("ERROR: too many DPIDs!"); // no need to set ok to 'false'
diff -ruN vdr-1.7.25/config.h vdr-1.7.26/config.h
--- vdr-1.7.25/config.h	2012-02-29 13:28:01.000000000 +0100
+++ vdr-1.7.26/config.h	2012-03-03 14:25:22.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: config.h 2.43 2012/02/29 12:28:01 kls Exp $
+ * $Id: config.h 2.44 2012/03/03 13:25:22 kls Exp $
  */
 
 #ifndef __CONFIG_H
@@ -22,13 +22,13 @@
 
 // VDR's own version number:
 
-#define VDRVERSION  "1.7.25"
-#define VDRVERSNUM   10725  // Version * 10000 + Major * 100 + Minor
+#define VDRVERSION  "1.7.26"
+#define VDRVERSNUM   10726  // Version * 10000 + Major * 100 + Minor
 
 // The plugin API's version number:
 
-#define APIVERSION  "1.7.25"
-#define APIVERSNUM   10725  // Version * 10000 + Major * 100 + Minor
+#define APIVERSION  "1.7.26"
+#define APIVERSNUM   10726  // Version * 10000 + Major * 100 + Minor
 
 // When loading plugins, VDR searches them by their APIVERSION, which
 // may be smaller than VDRVERSION in case there have been no changes to
diff -ruN vdr-1.7.25/device.c vdr-1.7.26/device.c
--- vdr-1.7.25/device.c	2012-03-03 12:43:05.000000000 +0100
+++ vdr-1.7.26/device.c	2012-03-07 15:17:49.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: device.c 2.55 2012/03/03 11:43:05 kls Exp $
+ * $Id: device.c 2.57 2012/03/07 14:17:49 kls Exp $
  */
 
 #include "device.h"
@@ -68,7 +68,6 @@
 int cDevice::currentChannel = 1;
 cDevice *cDevice::device[MAXDEVICES] = { NULL };
 cDevice *cDevice::primaryDevice = NULL;
-cDevice *cDevice::avoidDevice = NULL;
 cList<cDeviceHook> cDevice::deviceHooks;
 
 cDevice::cDevice(void)
@@ -228,8 +227,6 @@
 
 cDevice *cDevice::GetDevice(const cChannel *Channel, int Priority, bool LiveView, bool Query)
 {
-  cDevice *AvoidDevice = avoidDevice;
-  avoidDevice = NULL;
   // Collect the current priorities of all CAM slots that can decrypt the channel:
   int NumCamSlots = CamSlots.Count();
   int SlotPriority[NumCamSlots];
@@ -259,8 +256,6 @@
       if (NumUsableSlots && SlotPriority[j] > MAXPRIORITY)
          continue; // there is no CAM available in this slot
       for (int i = 0; i < numDevices; i++) {
-          if (device[i] == AvoidDevice)
-             continue; // this device shall be temporarily avoided
           if (Channel->Ca() && Channel->Ca() <= CA_DVB_MAX && Channel->Ca() != device[i]->CardIndex() + 1)
              continue; // a specific card was requested, but not this one
           if (NumUsableSlots && !CamSlots.Get(j)->Assign(device[i], true))
@@ -319,6 +314,26 @@
   return d;
 }
 
+cDevice *cDevice::GetDeviceForTransponder(const cChannel *Channel, int Priority)
+{
+  cDevice *Device = NULL;
+  for (int i = 0; i < cDevice::NumDevices(); i++) {
+      if (cDevice *d = cDevice::GetDevice(i)) {
+         if (d->IsTunedToTransponder(Channel))
+            return d; // if any device is tuned to the transponder, we're done
+         if (d->ProvidesTransponder(Channel)) {
+            if (d->MaySwitchTransponder(Channel))
+               Device = d; // this device may switch to the transponder without disturbing any receiver or live view
+            else if (!d->Occupied()) {
+               if (d->Priority() < Priority && (!Device || d->Priority() < Device->Priority()))
+                  Device = d; // use this one only if no other with less impact can be found
+               }
+            }
+         }
+      }
+  return Device;
+}
+
 bool cDevice::HasCi(void)
 {
   return false;
@@ -708,7 +723,7 @@
 
 eSetChannelResult cDevice::SetChannel(const cChannel *Channel, bool LiveView)
 {
-  cStatus::MsgChannelSwitch(this, 0);
+  cStatus::MsgChannelSwitch(this, 0, LiveView);
 
   if (LiveView) {
      StopReplay();
@@ -778,7 +793,7 @@
            EnsureAudioTrack(true);
         EnsureSubtitleTrack();
         }
-     cStatus::MsgChannelSwitch(this, Channel->Number()); // only report status if channel switch successfull
+     cStatus::MsgChannelSwitch(this, Channel->Number(), LiveView); // only report status if channel switch successfull
      }
 
   return Result;
diff -ruN vdr-1.7.25/device.h vdr-1.7.26/device.h
--- vdr-1.7.25/device.h	2012-03-02 11:23:13.000000000 +0100
+++ vdr-1.7.26/device.h	2012-03-06 13:13:46.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: device.h 2.36 2012/03/02 10:23:13 kls Exp $
+ * $Id: device.h 2.37 2012/03/06 12:13:46 kls Exp $
  */
 
 #ifndef __DEVICE_H
@@ -109,7 +109,6 @@
   static int useDevice;
   static cDevice *device[MAXDEVICES];
   static cDevice *primaryDevice;
-  static cDevice *avoidDevice;
 public:
   static int NumDevices(void) { return numDevices; }
          ///< Returns the total number of devices.
@@ -158,9 +157,11 @@
          ///< in order to just determine whether a device is available for the given
          ///< Channel.
          ///< See also ProvidesChannel().
-  static void SetAvoidDevice(cDevice *Device) { avoidDevice = Device; }
-         ///< Sets the given Device to be temporarily avoided in the next call to
-         ///< GetDevice(const cChannel, int, bool).
+  static cDevice *GetDeviceForTransponder(const cChannel *Channel, int Priority);
+         ///< Returns a device that is not currently "occupied" and can be tuned to
+         ///< the transponder of the given Channel, without disturbing any receiver
+         ///< at priorities higher or equal to Priority.
+         ///< If no such device is currently available, NULL will be returned.
   static void Shutdown(void);
          ///< Closes down all devices.
          ///< Must be called at the end of the program.
diff -ruN vdr-1.7.25/dvbdevice.c vdr-1.7.26/dvbdevice.c
--- vdr-1.7.25/dvbdevice.c	2012-02-29 13:23:43.000000000 +0100
+++ vdr-1.7.26/dvbdevice.c	2012-03-08 10:49:58.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: dvbdevice.c 2.65 2012/02/29 12:23:43 kls Exp $
+ * $Id: dvbdevice.c 2.67 2012/03/08 09:49:58 kls Exp $
  */
 
 #include "dvbdevice.h"
@@ -420,7 +420,7 @@
   if (cDvbTuner *t = bondedTuner) {
      cString BondingParams = GetBondingParams(Channel);
      do {
-        if (t->device->Receiving() || ConsiderOccupied && t->device->Occupied()) {
+        if (t->device->Priority() > IDLEPRIORITY || ConsiderOccupied && t->device->Occupied()) {
            if (strcmp(BondingParams, t->GetBondingParams()) != 0)
               return false;
            }
@@ -1446,7 +1446,7 @@
      if (Priority >= 0) {
         if (Receiving()) {
            if (dvbTuner->IsTunedTo(Channel)) {
-              if (Channel->Vpid() && !HasPid(Channel->Vpid()) || Channel->Apid(0) && !HasPid(Channel->Apid(0))) {
+              if (Channel->Vpid() && !HasPid(Channel->Vpid()) || Channel->Apid(0) && !HasPid(Channel->Apid(0)) || Channel->Dpid(0) && !HasPid(Channel->Dpid(0))) {
                  if (CamSlot() && Channel->Ca() >= CA_ENCRYPTED_MIN) {
                     if (CamSlot()->CanDecrypt(Channel))
                        result = true;
diff -ruN vdr-1.7.25/eit.c vdr-1.7.26/eit.c
--- vdr-1.7.25/eit.c	2012-02-25 16:25:51.000000000 +0100
+++ vdr-1.7.26/eit.c	2012-03-10 15:43:52.000000000 +0100
@@ -8,7 +8,7 @@
  * Robert Schneider <Robert.Schneider@web.de> and Rolf Hakenes <hakenes@hippomi.de>.
  * Adapted to 'libsi' for VDR 1.3.0 by Marcel Wiesweg <marcel.wiesweg@gmx.de>.
  *
- * $Id: eit.c 2.13 2012/02/25 15:25:51 kls Exp $
+ * $Id: eit.c 2.15 2012/03/10 14:43:52 kls Exp $
  */
 
 #include "eit.h"
@@ -36,20 +36,13 @@
   cChannel *channel = Channels.GetByChannelID(channelID, true);
   if (!channel)
      return; // only collect data for known channels
+  if (EpgHandlers.IgnoreChannel(channel))
+     return;
 
   cSchedule *pSchedule = (cSchedule *)Schedules->GetSchedule(channel, true);
-  if (pSchedule) {
-     if (cEvent *Event = pSchedule->Events()->First()) {
-        if (Event->TableID() == 0x00)
-           return; // never touch schedules with events from external sources
-        }
-     }
-  else
-     return;
 
   bool Empty = true;
   bool Modified = false;
-  bool HasExternalData = false;
   time_t SegmentStart = 0;
   time_t SegmentEnd = 0;
   time_t Now = time(NULL);
@@ -61,7 +54,8 @@
 
   SI::EIT::Event SiEitEvent;
   for (SI::Loop::Iterator it; eventLoop.getNext(SiEitEvent, it); ) {
-      bool ExternalData = false;
+      if (EpgHandlers.HandleEitEvent(pSchedule, &SiEitEvent, Tid, getVersionNumber()))
+         continue; // an EPG handler has done all of the processing
       time_t StartTime = SiEitEvent.getStartTime();
       int Duration = SiEitEvent.getDuration();
       // Drop bogus events - but keep NVOD reference events, where all bits of the start time field are set to 1, resulting in a negative number.
@@ -80,23 +74,17 @@
          // If we don't have that event yet, we create a new one.
          // Otherwise we copy the information into the existing event anyway, because the data might have changed.
          pEvent = newEvent = new cEvent(SiEitEvent.getEventId());
-         if (!pEvent)
-            continue;
+         newEvent->SetStartTime(StartTime);
+         newEvent->SetDuration(Duration);
+         pSchedule->AddEvent(newEvent);
          }
       else {
          // We have found an existing event, either through its event ID or its start time.
          pEvent->SetSeen();
-         // If the existing event has a zero table ID it was defined externally and shall
-         // not be overwritten.
-         uchar TableID = pEvent->TableID();
-         if (TableID == 0x00) {
-            if (pEvent->Version() == getVersionNumber())
-               continue;
-            HasExternalData = ExternalData = true;
-            }
+         uchar TableID = max(pEvent->TableID(), uchar(0x4E)); // for backwards compatibility, table ids less than 0x4E are treated as if they were "present"
          // If the new event has a higher table ID, let's skip it.
          // The lower the table ID, the more "current" the information.
-         else if (Tid > TableID)
+         if (Tid > TableID)
             continue;
          // If the new event comes from the same table and has the same version number
          // as the existing one, let's skip it to avoid unnecessary work.
@@ -106,21 +94,20 @@
          // to the Sat.1/Pro7 transponder, events will keep toggling because of the bogus version numbers.
          else if (Tid == TableID && pEvent->Version() == getVersionNumber())
             continue;
+         EpgHandlers.SetEventID(pEvent, SiEitEvent.getEventId()); // unfortunately some stations use different event ids for the same event in different tables :-(
+         EpgHandlers.SetStartTime(pEvent, StartTime);
+         EpgHandlers.SetDuration(pEvent, Duration);
          }
-      if (!ExternalData) {
-         pEvent->SetEventID(SiEitEvent.getEventId()); // unfortunately some stations use different event ids for the same event in different tables :-(
+      if (pEvent->TableID() > 0x4E) // for backwards compatibility, table ids less than 0x4E are never overwritten
          pEvent->SetTableID(Tid);
-         pEvent->SetStartTime(StartTime);
-         pEvent->SetDuration(Duration);
-         }
-      if (newEvent)
-         pSchedule->AddEvent(newEvent);
       if (Tid == 0x4E) { // we trust only the present/following info on the actual TS
          if (SiEitEvent.getRunningStatus() >= SI::RunningStatusNotRunning)
             pSchedule->SetRunningStatus(pEvent, SiEitEvent.getRunningStatus(), channel);
          }
-      if (OnlyRunningStatus)
+      if (OnlyRunningStatus) {
+         pEvent->SetVersion(0xFF); // we have already changed the table id above, so set the version to an invalid value to make sure the next full run will be executed
          continue; // do this before setting the version, so that the full update can be done later
+         }
       pEvent->SetVersion(getVersionNumber());
 
       int LanguagePreferenceShort = -1;
@@ -132,10 +119,6 @@
       cLinkChannels *LinkChannels = NULL;
       cComponents *Components = NULL;
       for (SI::Loop::Iterator it2; (d = SiEitEvent.eventDescriptors.getNext(it2)); ) {
-          if (ExternalData && d->getDescriptorTag() != SI::ComponentDescriptorTag) {
-             delete d;
-             continue;
-             }
           switch (d->getDescriptorTag()) {
             case SI::ExtendedEventDescriptorTag: {
                  SI::ExtendedEventDescriptor *eed = (SI::ExtendedEventDescriptor *)d;
@@ -172,7 +155,7 @@
                         NumContents++;
                         }
                      }
-                 pEvent->SetContents(Contents);
+                 EpgHandlers.SetContents(pEvent, Contents);
                  }
                  break;
             case SI::ParentalRatingDescriptorTag: {
@@ -191,7 +174,7 @@
                           case 0x13:          ParentalRating = 16; break;
                           default:            ParentalRating = 0;
                           }
-                        pEvent->SetParentalRating(ParentalRating);
+                        EpgHandlers.SetParentalRating(pEvent, ParentalRating);
                         }
                      }
                  }
@@ -210,7 +193,7 @@
                  else if (month == 0 && t.tm_mon == 11) // current month is jan, but event is in dec
                     t.tm_year--;
                  time_t vps = mktime(&t);
-                 pEvent->SetVps(vps);
+                 EpgHandlers.SetVps(pEvent, vps);
                  }
                  break;
             case SI::TimeShiftedEventDescriptorTag: {
@@ -221,9 +204,9 @@
                  rEvent = (cEvent *)rSchedule->GetEvent(tsed->getReferenceEventId());
                  if (!rEvent)
                     break;
-                 pEvent->SetTitle(rEvent->Title());
-                 pEvent->SetShortText(rEvent->ShortText());
-                 pEvent->SetDescription(rEvent->Description());
+                 EpgHandlers.SetTitle(pEvent, rEvent->Title());
+                 EpgHandlers.SetShortText(pEvent, rEvent->ShortText());
+                 EpgHandlers.SetDescription(pEvent, rEvent->Description());
                  }
                  break;
             case SI::LinkageDescriptorTag: {
@@ -281,30 +264,30 @@
       if (!rEvent) {
          if (ShortEventDescriptor) {
             char buffer[Utf8BufSize(256)];
-            pEvent->SetTitle(ShortEventDescriptor->name.getText(buffer, sizeof(buffer)));
-            pEvent->SetShortText(ShortEventDescriptor->text.getText(buffer, sizeof(buffer)));
+            EpgHandlers.SetTitle(pEvent, ShortEventDescriptor->name.getText(buffer, sizeof(buffer)));
+            EpgHandlers.SetShortText(pEvent, ShortEventDescriptor->text.getText(buffer, sizeof(buffer)));
             }
-         else if (!HasExternalData) {
-            pEvent->SetTitle(NULL);
-            pEvent->SetShortText(NULL);
+         else {
+            EpgHandlers.SetTitle(pEvent, NULL);
+            EpgHandlers.SetShortText(pEvent, NULL);
             }
          if (ExtendedEventDescriptors) {
             char buffer[Utf8BufSize(ExtendedEventDescriptors->getMaximumTextLength(": ")) + 1];
-            pEvent->SetDescription(ExtendedEventDescriptors->getText(buffer, sizeof(buffer), ": "));
+            EpgHandlers.SetDescription(pEvent, ExtendedEventDescriptors->getText(buffer, sizeof(buffer), ": "));
             }
-         else if (!HasExternalData)
-            pEvent->SetDescription(NULL);
+         else
+            EpgHandlers.SetDescription(pEvent, NULL);
          }
       delete ExtendedEventDescriptors;
       delete ShortEventDescriptor;
 
       pEvent->SetComponents(Components);
 
-      if (!HasExternalData)
-         pEvent->FixEpgBugs();
+      EpgHandlers.FixEpgBugs(pEvent);
       if (LinkChannels)
          channel->SetLinkChannels(LinkChannels);
       Modified = true;
+      EpgHandlers.HandleEvent(pEvent);
       }
   if (Tid == 0x4E) {
      if (Empty && getSectionNumber() == 0)
@@ -315,9 +298,8 @@
   if (OnlyRunningStatus)
      return;
   if (Modified) {
-     pSchedule->Sort();
-     if (!HasExternalData)
-        pSchedule->DropOutdated(SegmentStart, SegmentEnd, Tid, getVersionNumber());
+     EpgHandlers.SortSchedule(pSchedule);
+     EpgHandlers.DropOutdated(pSchedule, SegmentStart, SegmentEnd, Tid, getVersionNumber());
      Schedules->SetModified(pSchedule);
      }
 }
diff -ruN vdr-1.7.25/eitscan.c vdr-1.7.26/eitscan.c
--- vdr-1.7.25/eitscan.c	2011-09-25 16:58:55.000000000 +0200
+++ vdr-1.7.26/eitscan.c	2012-03-07 14:54:34.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: eitscan.c 2.5 2011/09/25 14:58:55 kls Exp $
+ * $Id: eitscan.c 2.6 2012/03/07 13:54:34 kls Exp $
  */
 
 #include "eitscan.h"
@@ -92,7 +92,6 @@
 cEITScanner::cEITScanner(void)
 {
   lastScan = lastActivity = time(NULL);
-  currentDevice = NULL;
   currentChannel = 0;
   scanList = NULL;
   transponderList = NULL;
@@ -159,10 +158,8 @@
                                            Skins.Message(mtInfo, tr("Starting EPG scan"));
                                            }
                                         }
-                                     currentDevice = Device;//XXX see also dvbdevice.c!!!
                                      //dsyslog("EIT scan: device %d  source  %-8s tp %5d", Device->DeviceNumber() + 1, *cSource::ToString(Channel->Source()), Channel->Transponder());
                                      Device->SwitchChannel(Channel, false);
-                                     currentDevice = NULL;
                                      scanList->Del(ScanData);
                                      AnyDeviceSwitched = true;
                                      break;
diff -ruN vdr-1.7.25/eitscan.h vdr-1.7.26/eitscan.h
--- vdr-1.7.25/eitscan.h	2005-09-04 12:51:35.000000000 +0200
+++ vdr-1.7.26/eitscan.h	2012-03-07 14:54:16.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: eitscan.h 2.0 2005/09/04 10:51:35 kls Exp $
+ * $Id: eitscan.h 2.1 2012/03/07 13:54:16 kls Exp $
  */
 
 #ifndef __EITSCAN_H
@@ -24,7 +24,6 @@
          ScanTimeout = 20
        };
   time_t lastScan, lastActivity;
-  cDevice *currentDevice;
   int currentChannel;
   cScanList *scanList;
   cTransponderList *transponderList;
@@ -32,7 +31,6 @@
   cEITScanner(void);
   ~cEITScanner();
   bool Active(void) { return currentChannel || lastActivity == 0; }
-  bool UsesDevice(const cDevice *Device) { return currentDevice == Device; }
   void AddTransponder(cChannel *Channel);
   void ForceScan(void);
   void Activity(void);
diff -ruN vdr-1.7.25/epg.c vdr-1.7.26/epg.c
--- vdr-1.7.25/epg.c	2012-02-13 15:58:19.000000000 +0100
+++ vdr-1.7.26/epg.c	2012-03-10 14:14:27.000000000 +0100
@@ -7,7 +7,7 @@
  * Original version (as used in VDR before 1.3.0) written by
  * Robert Schneider <Robert.Schneider@web.de> and Rolf Hakenes <hakenes@hippomi.de>.
  *
- * $Id: epg.c 2.11 2012/02/13 14:58:19 kls Exp $
+ * $Id: epg.c 2.12 2012/03/10 13:14:27 kls Exp $
  */
 
 #include "epg.h"
@@ -114,7 +114,7 @@
 {
   schedule = NULL;
   eventID = EventID;
-  tableID = 0;
+  tableID = 0xFF; // actual table ids are 0x4E..0x60
   version = 0xFF; // actual version numbers are 0..31
   runningStatus = SI::RunningStatusUndefined;
   title = NULL;
@@ -1296,3 +1296,153 @@
 {
   cSchedules::Read();
 }
+
+// --- cEpgHandler -----------------------------------------------------------
+
+cEpgHandler::cEpgHandler(void)
+{
+  EpgHandlers.Add(this);
+}
+
+cEpgHandler::~cEpgHandler()
+{
+  EpgHandlers.Del(this, false);
+}
+
+// --- cEpgHandlers ----------------------------------------------------------
+
+cEpgHandlers EpgHandlers;
+
+bool cEpgHandlers::IgnoreChannel(const cChannel *Channel)
+{
+  for (cEpgHandler *eh = First(); eh; eh = Next(eh)) {
+      if (eh->IgnoreChannel(Channel))
+         return true;
+      }
+  return false;
+}
+
+bool cEpgHandlers::HandleEitEvent(cSchedule *Schedule, const SI::EIT::Event *EitEvent, uchar TableID, uchar Version)
+{
+  for (cEpgHandler *eh = First(); eh; eh = Next(eh)) {
+      if (eh->HandleEitEvent(Schedule, EitEvent, TableID, Version))
+         return true;
+      }
+  return false;
+}
+
+void cEpgHandlers::SetEventID(cEvent *Event, tEventID EventID)
+{
+  for (cEpgHandler *eh = First(); eh; eh = Next(eh)) {
+      if (eh->SetEventID(Event, EventID))
+         return;
+      }
+  Event->SetEventID(EventID);
+}
+
+void cEpgHandlers::SetTitle(cEvent *Event, const char *Title)
+{
+  for (cEpgHandler *eh = First(); eh; eh = Next(eh)) {
+      if (eh->SetTitle(Event, Title))
+         return;
+      }
+  Event->SetTitle(Title);
+}
+
+void cEpgHandlers::SetShortText(cEvent *Event, const char *ShortText)
+{
+  for (cEpgHandler *eh = First(); eh; eh = Next(eh)) {
+      if (eh->SetShortText(Event, ShortText))
+         return;
+      }
+  Event->SetShortText(ShortText);
+}
+
+void cEpgHandlers::SetDescription(cEvent *Event, const char *Description)
+{
+  for (cEpgHandler *eh = First(); eh; eh = Next(eh)) {
+      if (eh->SetDescription(Event, Description))
+         return;
+      }
+  Event->SetDescription(Description);
+}
+
+void cEpgHandlers::SetContents(cEvent *Event, uchar *Contents)
+{
+  for (cEpgHandler *eh = First(); eh; eh = Next(eh)) {
+      if (eh->SetContents(Event, Contents))
+         return;
+      }
+  Event->SetContents(Contents);
+}
+
+void cEpgHandlers::SetParentalRating(cEvent *Event, int ParentalRating)
+{
+  for (cEpgHandler *eh = First(); eh; eh = Next(eh)) {
+      if (eh->SetParentalRating(Event, ParentalRating))
+         return;
+      }
+  Event->SetParentalRating(ParentalRating);
+}
+
+void cEpgHandlers::SetStartTime(cEvent *Event, time_t StartTime)
+{
+  for (cEpgHandler *eh = First(); eh; eh = Next(eh)) {
+      if (eh->SetStartTime(Event, StartTime))
+         return;
+      }
+  Event->SetStartTime(StartTime);
+}
+
+void cEpgHandlers::SetDuration(cEvent *Event, int Duration)
+{
+  for (cEpgHandler *eh = First(); eh; eh = Next(eh)) {
+      if (eh->SetDuration(Event, Duration))
+         return;
+      }
+  Event->SetDuration(Duration);
+}
+
+void cEpgHandlers::SetVps(cEvent *Event, time_t Vps)
+{
+  for (cEpgHandler *eh = First(); eh; eh = Next(eh)) {
+      if (eh->SetVps(Event, Vps))
+         return;
+      }
+  Event->SetVps(Vps);
+}
+
+void cEpgHandlers::FixEpgBugs(cEvent *Event)
+{
+  for (cEpgHandler *eh = First(); eh; eh = Next(eh)) {
+      if (eh->FixEpgBugs(Event))
+         return;
+      }
+  Event->FixEpgBugs();
+}
+
+void cEpgHandlers::HandleEvent(cEvent *Event)
+{
+  for (cEpgHandler *eh = First(); eh; eh = Next(eh)) {
+      if (eh->HandleEvent(Event))
+         break;
+      }
+}
+
+void cEpgHandlers::SortSchedule(cSchedule *Schedule)
+{
+  for (cEpgHandler *eh = First(); eh; eh = Next(eh)) {
+      if (eh->SortSchedule(Schedule))
+         return;
+      }
+  Schedule->Sort();
+}
+
+void cEpgHandlers::DropOutdated(cSchedule *Schedule, time_t SegmentStart, time_t SegmentEnd, uchar TableID, uchar Version)
+{
+  for (cEpgHandler *eh = First(); eh; eh = Next(eh)) {
+      if (eh->DropOutdated(Schedule, SegmentStart, SegmentEnd, TableID, Version))
+         return;
+      }
+  Schedule->DropOutdated(SegmentStart, SegmentEnd, TableID, Version);
+}
